﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

using Steema.TeeChart;

namespace ChartConfig
{
    public class ChartConfig
    {
        public static TChart createConfiguredChart(Font font)
        {
            Steema.TeeChart.TChart Chart = new Steema.TeeChart.TChart();

            //Chart.Header.Visible = false;
            Chart.Header.Font.Size = 11;
            Chart.Header.Font.Color = Color.Black;
            Chart.Header.Font.UsePrivateFont = true;
            Chart.Header.Font.DrawingFont = font;
            //Chart.Header.Font.Bold = font.Style == FontStyle.Bold;
            Chart.Header.TextFormat = Steema.TeeChart.Drawing.TextFormat.Html;
            Chart.Header.Text = "LOREM IPSUM";

            Chart.SubHeader.Visible = true;
            Chart.SubHeader.Font.Color = Color.Black;
            Chart.SubHeader.Font.UsePrivateFont = true;
            Chart.SubHeader.Font.DrawingFont = new Font(font.FontFamily.Name, 11);
            Chart.SubHeader.Text = "dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor\r\nincididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.";

            for (int i = 0; i < 9; i++)
            {
                new Steema.TeeChart.Styles.Line(Chart.Chart);
                Chart.Series[i].FillSampleValues();
            }
            Chart.Draw();

            Chart.Height = 550;
            Chart.Width = 710;
            //Chart.Height = 375;
            //Chart.Width = 500;
            Chart.Padding = new System.Windows.Forms.Padding(0);

            Chart.Aspect.View3D = false;

            Chart.Header.CustomPosition = true;
            Chart.Header.Alignment = StringAlignment.Near;
            Chart.Header.Left = 35;
            Chart.Header.Top = 10;

            Chart.SubHeader.CustomPosition = true;
            Chart.SubHeader.Alignment = StringAlignment.Near;
            Chart.SubHeader.Left = 37;
            Chart.SubHeader.Top = Chart.Header.Height + 10;

            Chart.Walls.Visible = false;

            Chart.Axes.Left.Grid.Style = System.Drawing.Drawing2D.DashStyle.Solid;
            Chart.Axes.Left.Grid.Color = Color.Black;
            Chart.Axes.Left.Ticks.Visible = false;
            Chart.Axes.Left.MinorTicks.Visible = false;
            Chart.Axes.Left.AxisPen.Visible = false;

            Chart.Axes.Bottom.Grid.Visible = false;
            Chart.Axes.Bottom.Ticks.Visible = false;
            Chart.Axes.Bottom.MinorTicks.Visible = false;
            Chart.Axes.Bottom.AxisPen.Color = Color.Black;
            Chart.Axes.Bottom.AxisPen.Width = 1;

            Chart.Footer.Font.Color = Color.Gray;

            Chart.Legend.Visible = true;
            Chart.Legend.Shadow.Visible = false;
            Chart.Legend.Pen.Visible = false;
            Chart.Legend.Color = ColorTranslator.FromHtml("#ceeafa");

            Chart.Legend.CustomPosition = true;
            Chart.Legend.Alignment = LegendAlignments.Bottom;
            Chart.Legend.AutoSize = false;
            //Chart.Legend.Height += 10;
            Chart.Legend.Width = Chart.Width;
            Chart.Legend.VertSpacing = 10;
            Chart.Legend.Left = 60;
            Chart.Legend.Top = Chart.Height - Chart.Legend.Height;
            Chart.Legend.ResizeChart = true;
            Chart.Legend.ColumnWidthAuto = false;
            Chart.Legend.ColumnWidths = new int[2];

            for (int i = 0; i < Chart.Legend.ColumnWidths.Length; i++)
                Chart.Legend.ColumnWidths[i] = (int)(Chart.Width / 5.5);

            Chart.Legend.Font.UsePrivateFont = false;
            Chart.Legend.Font.DrawingFont = font;

            Chart.Legend.Symbol.DefaultPen = false;
            Chart.Legend.Symbol.Pen.Visible = false;
            Chart.Legend.Symbol.WidthUnits = LegendSymbolSize.Pixels;
            Chart.Legend.Symbol.Width = 25;

            Chart.Panel.Gradient.Visible = false;
            Chart.Panel.Pen.Visible = false;
            Chart.Panel.Color = ColorTranslator.FromHtml("#e9f6fd");
            Chart.Panel.Bevel.Outer = Steema.TeeChart.Drawing.BevelStyles.None;

            Chart.Panel.MarginUnits = PanelMarginUnits.Pixels;
            Chart.Panel.MarginRight = 5;
            Chart.Panel.MarginBottom = Chart.Legend.Visible ? Chart.Legend.Height + 30 : 0;
            Chart.Panel.MarginTop = Chart.Header.Visible ? Chart.Header.Height : 0;

            if (Chart.SubHeader.Visible)
            {
                Chart.Panel.MarginTop += Chart.SubHeader.Height;
            }

            Chart.Panel.MarginTop += 15;

            foreach (Steema.TeeChart.Styles.Series s in Chart.Series)
            {
                if (s is Steema.TeeChart.Styles.Line)
                    ((Steema.TeeChart.Styles.Line)s).LinePen.Width = 4;
            }

            Chart.Series[0].Color = ColorTranslator.FromHtml("#3db7e4");
            Chart.Series[0].Title = "Aenean lacus ipsum, faucibus sit amet.";
            Chart.Series[1].Color = ColorTranslator.FromHtml("#053762");
            Chart.Series[1].Title = "Vivamus adipiscing placerat tristique.";
            Chart.Series[2].Color = ColorTranslator.FromHtml("#6a0041");
            Chart.Series[2].Title = "Proin vel auctor elit. Vivamus accumsan.";
            Chart.Series[3].Color = ColorTranslator.FromHtml("#676535");
            Chart.Series[3].Title = "Nulla feugiat quam id eros consectetur.";
            Chart.Series[4].Color = ColorTranslator.FromHtml("#df8d2f");
            Chart.Series[4].Title = "Donec viverra aliquet neque at feugiat.";
            Chart.Series[5].Color = ColorTranslator.FromHtml("#24a78f");
            Chart.Series[5].Title = "Suspendisse aliquet nibh at odio iaculis.";
            Chart.Series[6].Color = ColorTranslator.FromHtml("#c6d644");
            Chart.Series[6].Title = "Integer scelerisque lectus quis lorem.";
            Chart.Series[7].Color = ColorTranslator.FromHtml("#cc1c55");
            Chart.Series[7].Title = "Curabitur facilisis ligula dui, semper cursus.";
            Chart.Series[8].Color = ColorTranslator.FromHtml("#5b3900");
            Chart.Series[8].Title = "Nunc vehicula nunc sed nunc vestibulum.";

            return Chart;
        }
    }
}
